Index: tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/EditionPanel.java
===================================================================
--- tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/EditionPanel.java	(revision 2730)
+++ tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/EditionPanel.java	(revision 2731)
@@ -405,12 +452,12 @@
 					composite.b /= size;
 					
 					String s = String.format(colorscriptRuleFast, wordid, composite.r, composite.g, composite.b, composite.a);
-					buffer.append(s+"\n"); //$NON-NLS-1$
+					buffer.append(s + "\n"); //$NON-NLS-1$
 				}
 				
 				if (buffer.length() > 0) {
 					if (!execute(buffer.toString())) {
-						Log.fine("JS execution (color) error with="+buffer);
+						Log.fine("JS execution (color) error with=" + buffer);
 					}
 				}
 				
@@ -419,42 +466,43 @@
 				
 				for (String wordid : fontSizePerWordIDS.keySet()) {
 					String s = String.format(sizescriptRuleFast, wordid, fontSizePerWordIDS.get(wordid));
-					buffer.append(s+"\n"); //$NON-NLS-1$
+					buffer.append(s + "\n"); //$NON-NLS-1$
 				}
 				
 				for (String wordid : fontWeightPerWordIDS.keySet()) {
 					String s = null;
 					if (!fastWordHighLight) {
-						//s = String.format(highlightscriptRule, wordid, composite.r, composite.g, composite.b, composite.a);
-						s = "try { document.getElementById(\"" + wordid + "\").style.fontWeight=\""+fontWeightPerWordIDS.get(wordid)+"\";" //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-								+ 
-								//								"elt.style.paddingLeft=\"3px\";" + //$NON-NLS-1$
-								//								"elt.style.paddingRight=\"3px\";" + //$NON-NLS-1$
-								//								"elt.style.paddingTop=\"1px\";" + //$NON-NLS-1$
-								//								"elt.style.paddingBottom=\"1px\";" + //$NON-NLS-1$
+						// s = String.format(highlightscriptRule, wordid, composite.r, composite.g, composite.b, composite.a);
+						s = "try { document.getElementById(\"" + wordid + "\").style.fontWeight=\"" + fontWeightPerWordIDS.get(wordid) + "\";" //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+								+
+						// "elt.style.paddingLeft=\"3px\";" + //$NON-NLS-1$
+						// "elt.style.paddingRight=\"3px\";" + //$NON-NLS-1$
+						// "elt.style.paddingTop=\"1px\";" + //$NON-NLS-1$
+						// "elt.style.paddingBottom=\"1px\";" + //$NON-NLS-1$
 								"} catch (e) { };"; //$NON-NLS-1$
-						//s = String.format(highlightscriptRule, wordid, composite.r, composite.g, composite.b, composite.a);
-						//						s = "try { var elt = document.getElementById(\"" + wordid + "\");" + //$NON-NLS-1$ //$NON-NLS-2$
-						//								"elt.style.fontWeight=\""+fontWeightPerWordIDS.get(wordid)+"\";" + //$NON-NLS-1$
-						////								"elt.style.paddingLeft=\"3px\";" + //$NON-NLS-1$
-						////								"elt.style.paddingRight=\"3px\";" + //$NON-NLS-1$
-						////								"elt.style.paddingTop=\"1px\";" + //$NON-NLS-1$
-						////								"elt.style.paddingBottom=\"1px\";" + //$NON-NLS-1$
-						//								"} catch (e) { };"; //$NON-NLS-1$
-					} else {
+						// s = String.format(highlightscriptRule, wordid, composite.r, composite.g, composite.b, composite.a);
+						// s = "try { var elt = document.getElementById(\"" + wordid + "\");" + //$NON-NLS-1$ //$NON-NLS-2$
+						// "elt.style.fontWeight=\""+fontWeightPerWordIDS.get(wordid)+"\";" + //$NON-NLS-1$
+						//// "elt.style.paddingLeft=\"3px\";" + //$NON-NLS-1$
+						//// "elt.style.paddingRight=\"3px\";" + //$NON-NLS-1$
+						//// "elt.style.paddingTop=\"1px\";" + //$NON-NLS-1$
+						//// "elt.style.paddingBottom=\"1px\";" + //$NON-NLS-1$
+						// "} catch (e) { };"; //$NON-NLS-1$
+					}
+					else {
 						s = String.format(weightscriptRuleFast, wordid, fontWeightPerWordIDS.get(wordid));
 					}
-					buffer.append(s+"\n"); //$NON-NLS-1$
+					buffer.append(s + "\n"); //$NON-NLS-1$
 				}
 				
 				for (String wordid : fontFamillyPerWordIDS.keySet()) {
 					String s = String.format(famillyscriptRuleFast, wordid, fontFamillyPerWordIDS.get(wordid));
-					buffer.append(s+"\n"); //$NON-NLS-1$
+					buffer.append(s + "\n"); //$NON-NLS-1$
 				}
 				
 				if (buffer.length() > 0) {
 					if (!execute(buffer.toString())) {
-						Log.fine("JS execution (font) error with="+buffer);
+						Log.fine("JS execution (font) error with=" + buffer);
 					}
 				}
 				
@@ -462,17 +510,18 @@
 				buffer = new StringBuilder();
 				
 				if (focusedWordID != null) {
-					//System.out.println("Focus on: "+focusedWordID);
+					// System.out.println("Focus on: "+focusedWordID);
 					String s = "try { showElementIfNeeded(document.getElementById(\"" + focusedWordID + "\")); } catch (e) {document.getElementById(\"" + focusedWordID + "\").scrollIntoView();};"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-					buffer.append(s+"\n"); //$NON-NLS-1$
+					buffer.append(s + "\n"); //$NON-NLS-1$
 				}
 				
 				if (buffer.length() > 0) {
 					if (execute(buffer.toString())) {
 						focusedWordID = null; // focus one time
-					} else {
-						Log.fine("JS execution (focus) error with="+buffer);
 					}
+					else {
+						Log.fine("JS execution (focus) error with=" + buffer);
+					}
 				}
 				
 				
@@ -481,35 +530,39 @@
 				if (highlightedAreas != null) {
 					for (int[] pos : highlightedAreas) {
 						if (pos == null || pos.length != 4) continue;
-						String s = "try {v.setFocusOn("+pos[0]+", "+pos[1]+", "+pos[2]+", "+pos[3]+");} catch (e) { };"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
-						buffer.append(s+"\n"); //$NON-NLS-1$
+						String s = "try {v.setFocusOn(" + pos[0] + ", " + pos[1] + ", " + pos[2] + ", " + pos[3] + ");} catch (e) { };"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
+						buffer.append(s + "\n"); //$NON-NLS-1$
 						break;// one word only for now
 					}
 				}
 				
-				//System.out.println(buffer);
+				// System.out.println(buffer);
 				if (buffer.length() > 0) {
 					if (!execute(buffer.toString())) {
-						Log.fine("JS execution (area focus) error with="+buffer);
+						Log.fine("JS execution (area focus) error with=" + buffer);
 					}
 				}
-				//System.out.println("n="+n+" time="+(System.currentTimeMillis()-start));
+				// System.out.println("n="+n+" time="+(System.currentTimeMillis()-start));
 				
 				// do something after the highlight is done
-				for (ProgressListener pl : afterHighlighListeners) { pl.completed(event);}
+				for (ProgressListener pl : afterHighlighListeners) {
+					pl.completed(event);
+				}
 			}
 		};
 		
 		getBrowser().addMouseListener(new MouseListener() {
 			
 			boolean dblClick = false;
+			
 			boolean debug = false;
-			private int t,x,y;
 			
+			private int t, x, y;
+			
 			@Override
 			public void mouseDoubleClick(MouseEvent e) {
 				if (debug) System.out.println("DOUBLE CLICK"); //$NON-NLS-1$
-				dblClick= true;
+				dblClick = true;
 			}
 			
 			@Override
@@ -531,18 +584,18 @@
 				EditionPanel panel = EditionPanel.this;
 				
 				// filter click that are not a left simple click (no drag)
-				//System.out.println("click count="+e.count+" button="+e.button+" time="+e.time+" diff="+(e.time-t)+" dist="+(Math.abs(e.x - x) + Math.abs(e.y - y)));
+				// System.out.println("click count="+e.count+" button="+e.button+" time="+e.time+" diff="+(e.time-t)+" dist="+(Math.abs(e.x - x) + Math.abs(e.y - y)));
 				if (e.count > 1) {
 					if (debug) System.out.println(" DOUBLE CLICK"); //$NON-NLS-1$
-					//System.out.println("not a simple click");
+					// System.out.println("not a simple click");
 					return;
 				}
 				
 				int dist = Math.abs(e.x - x) + Math.abs(e.y - y);
-				int deltat = (e.time-t);
-				//System.out.println("deltat ="+deltat);
+				int deltat = (e.time - t);
+				// System.out.println("deltat ="+deltat);
 				if (dist >= 0 && (deltat > 0 || dist > 0)) {
-					//System.out.println(" DRAG dist="+dist+" deltat="+deltat);
+					// System.out.println(" DRAG dist="+dist+" deltat="+deltat);
 					String[] ids = panel.getWordSelection(); // may be null
 					
 					panel.expandSelectionTo(ids);
@@ -552,13 +605,14 @@
 		});
 		
 		getBrowser().addProgressListener(progresslistener);
-		new CommandLink (synopticEditionEditor, getBrowser());
-		new EditionLink (synopticEditionEditor, getBrowser());
+		new CommandLink(synopticEditionEditor, getBrowser());
+		new EditionLink(synopticEditionEditor, getBrowser());
 	}
 	
 	/**
 	 * Bypass BrowserViewer restriction on the getBrowser method
 	 */
+	@Override
 	public Browser getBrowser() {
 		return super.getBrowser();
 	}
@@ -567,7 +621,7 @@
 	 * Bypass BrowserViewer restriction on the getBrowser method
 	 */
 	public String getDOM() {
-		return "";//execute("return document.innerHTML"; //$NON-NLS-1$
+		return "";// execute("return document.innerHTML"; //$NON-NLS-1$
 	}
 	
 	public ISelectionProvider getSelectionProvider() {
@@ -579,7 +633,7 @@
 			if (this.highlightedColorPerWordIDS.get(wordid) != null) {
 				removeHighlightWordsById(color, wordid);
 			}
-			ArrayList<RGBA> hs = new ArrayList<RGBA>();
+			ArrayList<RGBA> hs = new ArrayList<>();
 			this.highlightedColorPerWordIDS.put(wordid, hs);
 			hs.add(color);
 		}
@@ -606,12 +660,12 @@
 	}
 	
 	public void removeHighlightWordsById(RGBA color, Collection<String> wordids) {
-		//System.out.println("Call removeHighlightWordsById: "+wordids+" color="+color);
+		// System.out.println("Call removeHighlightWordsById: "+wordids+" color="+color);
 		StringBuffer buffer = new StringBuffer();
 		for (String wordid : wordids) {
 			removeHighlightWordsById(color, wordid);
 			if (!fastWordHighLight) {
-				buffer.append(String.format(clearhighlightscript, wordid)+"\n"); //$NON-NLS-1$
+				buffer.append(String.format(clearhighlightscript, wordid) + "\n"); //$NON-NLS-1$
 			}
 		}
 		
@@ -621,7 +675,7 @@
 	public void removeHighlightWordsById(RGBA color, String wordid) {
 		if (highlightedColorPerWordIDS.get(wordid) == null) return; // nothing to do
 		
-		//System.out.println("remove color="+color+" from id="+wordid);
+		// System.out.println("remove color="+color+" from id="+wordid);
 		this.highlightedColorPerWordIDS.get(wordid).remove(color);
 		
 		if (this.highlightedColorPerWordIDS.get(wordid).size() == 0) {
@@ -631,6 +685,7 @@
 	
 	/**
 	 * Open the page containing the word with ID=$line_wordid
+	 * 
 	 * @param line_wordid
 	 * @return true if the page changed
 	 */
@@ -644,11 +699,13 @@
 			System.out.println(s);
 			StatusLine.setMessage(s);
 			Log.severe(s);
-		} else {
+		}
+		else {
 			Page openedPage = null;
 			if (line_wordid != null && line_wordid.length() > 0) {
 				openedPage = edition.getPageForWordId(line_wordid);
-			} else {
+			}
+			else {
 				openedPage = edition.getFirstPage();
 			}
 			if (openedPage != null && openedPage != currentPage) {
@@ -674,9 +731,10 @@
 		
 		this.setURL(currentPage.toURL());
 		
-		//page_label.setText(makePageLabel());
+		// page_label.setText(makePageLabel());
 	}
 	
+	@Override
 	public void setURL(String url) {
 		if (!this.browser.isDisposed()) {
 			super.setURL(url);
@@ -707,15 +765,17 @@
 			
 			if (previous == currentPage) {
 				previousText(true);
-			} else {
+			}
+			else {
 				currentPage = previous;
 				this.setURL(currentPage.toURL());
 			}
 			currentText = currentEdition.getText();
-		} else {
+		}
+		else {
 			firstPage();
 		}
-		//page_label.setText(makePageLabel());
+		// page_label.setText(makePageLabel());
 	}
 	
 	
@@ -729,25 +789,28 @@
 			Page next = currentEdition.getNextPage(currentPage);
 			if (next == currentPage) {
 				nextText();
-			} else {
+			}
+			else {
 				currentPage = next;
 				this.setURL(currentPage.toURL());
 			}
 			currentText = currentEdition.getText();
-		} else {
+		}
+		else {
 			firstPage();
 		}
-		//page_label.setText(makePageLabel());
+		// page_label.setText(makePageLabel());
 	}
 	
 	
 	public void firstText() {
-		//Text current = this.currentPage.getEdition().getText();
+		// Text current = this.currentPage.getEdition().getText();
 		Project project = currentText.getProject();
 		String id;
 		try {
 			id = this.synopticEditionEditor.getCorpus().getCorpusTextIdsList()[0];
-		} catch (Exception e) {
+		}
+		catch (Exception e) {
 			Log.printStackTrace(e);
 			return;
 		}
@@ -761,7 +824,7 @@
 				return;
 			}
 			currentEdition = tmp;
-			currentPage = currentEdition.getFirstPage(); 
+			currentPage = currentEdition.getFirstPage();
 			currentText = firstText;
 			if (currentPage == null) {
 				StatusLine.setMessage("No previous text"); //$NON-NLS-1$
@@ -775,13 +838,14 @@
 	 * Next text.
 	 */
 	public void lastText() {
-		//Text current = this.currentPage.getEdition().getText();
+		// Text current = this.currentPage.getEdition().getText();
 		Project project = currentText.getProject();
 		String id;
 		try {
 			String[] ids = this.synopticEditionEditor.getCorpus().getCorpusTextIdsList();
-			id = ids[ids.length-1];
-		} catch (Exception e) {
+			id = ids[ids.length - 1];
+		}
+		catch (Exception e) {
 			Log.printStackTrace(e);
 			return;
 		}
@@ -796,7 +860,7 @@
 			}
 			
 			currentEdition = tmp;
-			currentPage = currentEdition.getFirstPage(); 
+			currentPage = currentEdition.getFirstPage();
 			currentText = lastText;
 			if (currentPage == null) {
 				StatusLine.setMessage("No text next"); //$NON-NLS-1$
@@ -804,14 +868,15 @@
 			}
 			
 			this.setURL(currentPage.toURL());
-			//page_label.setText(makePageLabel());
+			// page_label.setText(makePageLabel());
 		}
 		// System.out.println("Next texts "+nextText);
 	}
 	
 	/**
 	 * Previous text.
-	 * @param fromNextText if true  it means the user was reading the next text and then we show the last page of the previous text
+	 * 
+	 * @param fromNextText if true it means the user was reading the next text and then we show the last page of the previous text
 	 */
 	public void previousText(boolean fromNextText) {
 		
@@ -821,7 +886,7 @@
 			String[] ids = this.synopticEditionEditor.getCorpus().getCorpusTextIdsList();
 			String currentId = currentText.getName();
 			int idx = 0;
-			for (int i = 0 ; i < ids.length ;i++) {
+			for (int i = 0; i < ids.length; i++) {
 				if (currentId.equals(ids[i])) {
 					idx = i;
 					break;
@@ -829,7 +894,8 @@
 			}
 			if (idx > 0) idx--;
 			id = ids[idx];
-		} catch (Exception e) {
+		}
+		catch (Exception e) {
 			e.printStackTrace();
 			return;
 		}
@@ -846,10 +912,11 @@
 			currentEdition = tmp;
 			currentText = previousText;
 			if (fromNextText) {
-				currentPage = currentEdition.getLastPage(); 
-			} else {
-				currentPage = currentEdition.getFirstPage(); 
+				currentPage = currentEdition.getLastPage();
 			}
+			else {
+				currentPage = currentEdition.getFirstPage();
+			}
 			
 			if (currentPage == null) {
 				StatusLine.setMessage("No previous text"); //$NON-NLS-1$
@@ -864,14 +931,14 @@
 	 * Next text.
 	 */
 	public void nextText() {
-		//Text current = this.currentPage.getEdition().getText();
+		// Text current = this.currentPage.getEdition().getText();
 		Project project = currentText.getProject();
 		String id;
 		try {
 			String[] ids = this.synopticEditionEditor.getCorpus().getCorpusTextIdsList();
 			String currentId = currentText.getName();
 			int idx = 0;
-			for (int i = 0 ; i < ids.length ;i++) {
+			for (int i = 0; i < ids.length; i++) {
 				if (currentId.equals(ids[i])) {
 					idx = i;
 					break;
@@ -879,7 +946,8 @@
 			}
 			if (idx < ids.length - 1) idx++;
 			id = ids[idx];
-		} catch (Exception e) {
+		}
+		catch (Exception e) {
 			e.printStackTrace();
 			return;
 		}
@@ -894,7 +962,7 @@
 			}
 			currentEdition = tmp;
 			
-			currentPage = currentEdition.getFirstPage(); 
+			currentPage = currentEdition.getFirstPage();
 			currentText = nextText;
 			if (currentPage == null) {
 				StatusLine.setMessage("No text next"); //$NON-NLS-1$
@@ -902,7 +970,7 @@
 			}
 			
 			this.setURL(currentPage.toURL());
-			//page_label.setText(makePageLabel());
+			// page_label.setText(makePageLabel());
 		}
 		// System.out.println("Next texts "+nextText);
 	}
@@ -917,7 +985,7 @@
 		}
 		
 		currentEdition = tmp;
-		currentPage = currentEdition.getFirstPage(); 
+		currentPage = currentEdition.getFirstPage();
 		currentText = text;
 		if (currentPage == null) {
 			StatusLine.setMessage("No text next"); //$NON-NLS-1$
@@ -927,7 +995,7 @@
 		if (refresh) {
 			this.setURL(currentPage.toURL());
 		}
-		//page_label.setText(makePageLabel());
+		// page_label.setText(makePageLabel());
 	}
 	
 	/**
@@ -963,7 +1031,7 @@
 	 * @param page the page
 	 */
 	public void showPage(Page page) {
-		//System.out.println("SHOW PAGE "+page);
+		// System.out.println("SHOW PAGE "+page);
 		currentEdition = page.getEdition();
 		currentText = currentEdition.getText();
 		currentPage = page;
@@ -974,30 +1042,30 @@
 		this.setURL(currentPage.toURL());
 	}
 	
-	//	/**
-	//	 * Sets the edition.
-	//	 *
-	//	 * @param edition the new edition
-	//	 */
-	//	public void setEdition(Edition edition) {
-	//		this.currentEdition = edition;
-	//	}
+	// /**
+	// * Sets the edition.
+	// *
+	// * @param edition the new edition
+	// */
+	// public void setEdition(Edition edition) {
+	// this.currentEdition = edition;
+	// }
 	
-	static String SCRIPT01 = "var html = \"\";"+ //$NON-NLS-1$
-			"if (typeof window.getSelection != \"undefined\") {"+ // modern Web browsers //$NON-NLS-1$
-			"var sel = window.getSelection();"+ //$NON-NLS-1$
-			"if (sel.rangeCount) {"+ //$NON-NLS-1$
-			"var container = document.createElement(\"div\");"+ //$NON-NLS-1$
-			"for (var i = 0, len = sel.rangeCount; i < len; ++i) {"+ //$NON-NLS-1$
-			"container.appendChild(sel.getRangeAt(i).cloneContents());"+ //$NON-NLS-1$
-			"}"+ //$NON-NLS-1$
-			"html = container.innerHTML;"+ //$NON-NLS-1$
-			"}"+ //$NON-NLS-1$
-			"} else if (typeof document.selection != \"undefined\") {"+ // for IE < 11 //$NON-NLS-1$
-			"if (document.selection.type == \"Text\") {"+ //$NON-NLS-1$
-			"html = document.selection.createRange().htmlText;"+ //$NON-NLS-1$
+	static String SCRIPT01 = "var html = \"\";" + //$NON-NLS-1$
+			"if (typeof window.getSelection != \"undefined\") {" + // modern Web browsers //$NON-NLS-1$
+			"var sel = window.getSelection();" + //$NON-NLS-1$
+			"if (sel.rangeCount) {" + //$NON-NLS-1$
+			"var container = document.createElement(\"div\");" + //$NON-NLS-1$
+			"for (var i = 0, len = sel.rangeCount; i < len; ++i) {" + //$NON-NLS-1$
+			"container.appendChild(sel.getRangeAt(i).cloneContents());" + //$NON-NLS-1$
 			"}" + //$NON-NLS-1$
+			"html = container.innerHTML;" + //$NON-NLS-1$
 			"}" + //$NON-NLS-1$
+			"} else if (typeof document.selection != \"undefined\") {" + // for IE < 11 //$NON-NLS-1$
+			"if (document.selection.type == \"Text\") {" + //$NON-NLS-1$
+			"html = document.selection.createRange().htmlText;" + //$NON-NLS-1$
+			"}" + //$NON-NLS-1$
+			"}" + //$NON-NLS-1$
 			"return html"; //$NON-NLS-1$
 	
 	public String getTextSelectionDOM() {
@@ -1010,74 +1078,77 @@
 	 */
 	public String[] getWordSelection() {
 		
-		//System.out.println("getWordSelection");
-		String SCRIPT02_getspans = ""//functions //$NON-NLS-1$
-				+"var all = [];" //$NON-NLS-1$
-				+"\nvar sel = txmGetSelection();" //$NON-NLS-1$
-				+"\nif (sel.rangeCount == 0) {return all;}" //$NON-NLS-1$
-				//+"\nalert('sel='+sel);"
-				+"\nvar range = txmGetRange(sel, 0);" //$NON-NLS-1$
-				//+"\nalert('range='+range);"
-				+"\nvar frag = txmGetFragment(range);" //$NON-NLS-1$
-				//+"\nalert('frag='+frag);"
-				+"\nvar children = txmGetChildren(frag);" //$NON-NLS-1$
-				//+"\nalert('children='+children);"
-				//+"\nalert('children.length='+children.length);"
-				+"\nif ((children.length == 0) || (children.length == 1 && children.item(0).nodeType == 3)) {" //$NON-NLS-1$
-				+"\n	var parent = txmGetParentElementRange(range);" //$NON-NLS-1$
-				//+"\n	if (parent instanceof HTMLHtmlElement) {alert('HTMLHtmlElement parent='+parent);return findIdsInString(parent, all);}"
-				+"\n	if (typeof parent.getAttribute == 'undefined') {return all}" //$NON-NLS-1$
-				+"\n	var id = parent.getAttribute('id');" //$NON-NLS-1$
-				+"\n	if (txmGetTagName(parent) == 'SPAN' && id != null && id.indexOf('w_') == 0) {" //$NON-NLS-1$
-				+"\n		all.push(id);" //$NON-NLS-1$
-				+"\n	} else {" // try with the parent's parent  //$NON-NLS-1$
-				+"\n		var parent = txmGetParent(parent);" //$NON-NLS-1$
-				//+"\n		alert('text selection, parent='+txmGetTagName(parent))"
-				+"\n	if (typeof parent.getAttribute == 'undefined') {return all}" //$NON-NLS-1$
-				+"\n		var id = parent.getAttribute('id');" //$NON-NLS-1$
-				+"\n		if (txmGetTagName(parent) == 'SPAN' && id != null && id.indexOf('w_') == 0) {" //$NON-NLS-1$
-				+"\n			all.push(id);" //$NON-NLS-1$
-				+"\n		}" //$NON-NLS-1$
-				+"\n	}" //$NON-NLS-1$
-				+"\n} else {" //$NON-NLS-1$
-				+"\n	findSpans(children, all);" //$NON-NLS-1$
-				+"\n}" //$NON-NLS-1$
-				//+"alert('result='+all)"
-				+"\nreturn all;"; //$NON-NLS-1$
+		// System.out.println("getWordSelection");
+		String SCRIPT02_getspans = ""// functions //$NON-NLS-1$
+				+ "var all = [];" //$NON-NLS-1$
+				+ "\nvar sel = txmGetSelection();" //$NON-NLS-1$
+				+ "\nif (sel.rangeCount == 0) {return all;}" //$NON-NLS-1$
+				// +"\nalert('sel='+sel);"
+				+ "\nvar range = txmGetRange(sel, 0);" //$NON-NLS-1$
+				// +"\nalert('range='+range);"
+				+ "\nvar frag = txmGetFragment(range);" //$NON-NLS-1$
+				// +"\nalert('frag='+frag);"
+				+ "\nvar children = txmGetChildren(frag);" //$NON-NLS-1$
+				// +"\nalert('children='+children);"
+				// +"\nalert('children.length='+children.length);"
+				+ "\nif ((children.length == 0) || (children.length == 1 && children.item(0).nodeType == 3)) {" //$NON-NLS-1$
+				+ "\n	var parent = txmGetParentElementRange(range);" //$NON-NLS-1$
+				// +"\n if (parent instanceof HTMLHtmlElement) {alert('HTMLHtmlElement parent='+parent);return findIdsInString(parent, all);}"
+				+ "\n	if (typeof parent.getAttribute == 'undefined') {return all}" //$NON-NLS-1$
+				+ "\n	var id = parent.getAttribute('id');" //$NON-NLS-1$
+				+ "\n	if (txmGetTagName(parent) == 'SPAN' && id != null && id.indexOf('w_') == 0) {" //$NON-NLS-1$
+				+ "\n		all.push(id);" //$NON-NLS-1$
+				+ "\n	} else {" // try with the parent's parent //$NON-NLS-1$
+				+ "\n		var parent = txmGetParent(parent);" //$NON-NLS-1$
+				// +"\n alert('text selection, parent='+txmGetTagName(parent))"
+				+ "\n	if (typeof parent.getAttribute == 'undefined') {return all}" //$NON-NLS-1$
+				+ "\n		var id = parent.getAttribute('id');" //$NON-NLS-1$
+				+ "\n		if (txmGetTagName(parent) == 'SPAN' && id != null && id.indexOf('w_') == 0) {" //$NON-NLS-1$
+				+ "\n			all.push(id);" //$NON-NLS-1$
+				+ "\n		}" //$NON-NLS-1$
+				+ "\n	}" //$NON-NLS-1$
+				+ "\n} else {" //$NON-NLS-1$
+				+ "\n	findSpans(children, all);" //$NON-NLS-1$
+				+ "\n}" //$NON-NLS-1$
+				// +"alert('result='+all)"
+				+ "\nreturn all;"; //$NON-NLS-1$
+				
+		// System.out.println(functions);
+		// System.out.println(SCRIPT02_getspans);
 		
-		//		System.out.println(functions);
-		//		System.out.println(SCRIPT02_getspans);
-		
 		Object ret = evaluate(SCRIPT02_getspans);
 		if (ret instanceof Object[]) {
-			Log.finer("selection word ids="+Arrays.toString((Object[])ret)); //$NON-NLS-1$
-			Object[] array = (Object[])ret;
+			Log.finer("selection word ids=" + Arrays.toString((Object[]) ret)); //$NON-NLS-1$
+			Object[] array = (Object[]) ret;
 			String[] sel = new String[2];
 			if (array.length == 0) {
 				return null;
-			} else if (array.length == 1) {
+			}
+			else if (array.length == 1) {
 				sel[0] = array[0].toString();
 				return sel;
-			} else {
+			}
+			else {
 				sel[0] = array[0].toString();
-				sel[1] = array[array.length-1].toString();
+				sel[1] = array[array.length - 1].toString();
 				return sel;
 			}
-		} else { 
+		}
+		else {
 			Log.severe(EditionUIMessages.bind(EditionUIMessages.sCRIPTRETURNEDEqualsP0, ret));
 			return null;
 		}
 	}
 	
 	public String getTextSelection() {
-		//System.out.println("DOM="+getTextSelectionDOM());
-		String rez =  getTextSelectionDOM().replaceAll("<[^>]+>", ""); //$NON-NLS-1$ //$NON-NLS-2$
-		//System.out.println("STR="+rez);
+		// System.out.println("DOM="+getTextSelectionDOM());
+		String rez = getTextSelectionDOM().replaceAll("<[^>]+>", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		// System.out.println("STR="+rez);
 		return rez;
 	}
 	
 	@Override
-	public void addSelectionChangedListener(ISelectionChangedListener listener) {	}
+	public void addSelectionChangedListener(ISelectionChangedListener listener) {}
 	
 	@Override
 	public ISelection getSelection() {
@@ -1086,13 +1157,15 @@
 	
 	@Override
 	public void removeSelectionChangedListener(
-			ISelectionChangedListener listener) {	}
+			ISelectionChangedListener listener) {}
 	
 	@Override
-	public void setSelection(ISelection selection) {	}
+	public void setSelection(ISelection selection) {}
 	
-	static public class SynopticTextSelection implements ISelection  {
+	static public class SynopticTextSelection implements ISelection {
+		
 		String str;
+		
 		public SynopticTextSelection(EditionPanel panel) {
 			this.str = panel.getTextSelection();
 		}
@@ -1111,13 +1184,13 @@
 		return currentEdition;
 	}
 	
-	public MenuManager getMenuManager() {	
+	public MenuManager getMenuManager() {
 		return menuManager;
 	}
 	
 	public void initMenu() {
-		// create a new menu	
-		menuManager = new MenuManager(); //$NON-NLS-1$
+		// create a new menu
+		menuManager = new MenuManager();
 		
 		Menu menu = menuManager.createContextMenu(this.getBrowser());
 		
@@ -1142,7 +1215,7 @@
 					}
 					
 					@Override
-					public void widgetDefaultSelected(SelectionEvent e) { }
+					public void widgetDefaultSelected(SelectionEvent e) {}
 				});
 				String text = EditionPanel.this.getTextSelection();
 				copyItem.setEnabled(text != null && text.length() > 0);
@@ -1157,7 +1230,7 @@
 					}
 					
 					@Override
-					public void widgetDefaultSelected(SelectionEvent e) { }
+					public void widgetDefaultSelected(SelectionEvent e) {}
 				});
 				MenuItem backItem = new MenuItem(menu, SWT.NONE);
 				backItem.setText(EditionUIMessages.back);
@@ -1169,7 +1242,7 @@
 					}
 					
 					@Override
-					public void widgetDefaultSelected(SelectionEvent e) { }
+					public void widgetDefaultSelected(SelectionEvent e) {}
 				});
 				MenuItem forwardItem = new MenuItem(menu, SWT.NONE);
 				forwardItem.setText(EditionUIMessages.forward);
@@ -1181,7 +1254,7 @@
 					}
 					
 					@Override
-					public void widgetDefaultSelected(SelectionEvent e) { }
+					public void widgetDefaultSelected(SelectionEvent e) {}
 				});
 			}
 			
@@ -1190,52 +1263,73 @@
 				// TODO Auto-generated method stub
 			}
 		});
-		//		// restore old listeners
-		//		Menu origMenu = this.browser.getMenu();
-		//		if (origMenu != null) {
-		//			if (origMenu.getListeners(SWT.Hide) != null)
-		//				for (Listener listener : origMenu.getListeners(SWT.Hide)) menu.addListener(SWT.Hide, listener);
-		//			if (origMenu.getListeners(SWT.Show) != null)
-		//				for (Listener listener : origMenu.getListeners(SWT.Show)) menu.addListener(SWT.Show, listener);
-		//			for (MenuItem origItem : origMenu.getItems()) { // restore old menu items
-		//				MenuItem item = new MenuItem(menu, origItem.getStyle());
-		//				item.setText(origItem.getText());
-		//				item.setImage(origItem.getImage());
-		//				if (origItem.getListeners(SWT.Selection) != null && origItem.getListeners(SWT.Selection).length > 0)
-		//					item.addListener(SWT.Selection, origItem.getListeners(SWT.Selection)[0]);
-		//			}
-		//		}
+		// // restore old listeners
+		// Menu origMenu = this.browser.getMenu();
+		// if (origMenu != null) {
+		// if (origMenu.getListeners(SWT.Hide) != null)
+		// for (Listener listener : origMenu.getListeners(SWT.Hide)) menu.addListener(SWT.Hide, listener);
+		// if (origMenu.getListeners(SWT.Show) != null)
+		// for (Listener listener : origMenu.getListeners(SWT.Show)) menu.addListener(SWT.Show, listener);
+		// for (MenuItem origItem : origMenu.getItems()) { // restore old menu items
+		// MenuItem item = new MenuItem(menu, origItem.getStyle());
+		// item.setText(origItem.getText());
+		// item.setImage(origItem.getImage());
+		// if (origItem.getListeners(SWT.Selection) != null && origItem.getListeners(SWT.Selection).length > 0)
+		// item.addListener(SWT.Selection, origItem.getListeners(SWT.Selection)[0]);
+		// }
+		// }
 		// replace the menu
-		this.getBrowser().setMenu(menu); 
+		this.getBrowser().setMenu(menu);
 	}
 	
 	public void initSelectionProvider() {
 		selProvider = new ISelectionProvider() {
+			
 			@Override
-			public void setSelection(ISelection selection) { }
+			public void setSelection(ISelection selection) {}
+			
 			@Override
-			public void removeSelectionChangedListener(ISelectionChangedListener listener) { }
+			public void removeSelectionChangedListener(ISelectionChangedListener listener) {}
+			
 			@Override
 			public ISelection getSelection() {
 				ITextSelection sel = new ITextSelection() {
+					
 					@Override
-					public boolean isEmpty() {return EditionPanel.this.getTextSelection().length() == 0;}
+					public boolean isEmpty() {
+						return EditionPanel.this.getTextSelection().length() == 0;
+					}
+					
 					@Override
-					public String getText() {return EditionPanel.this.getTextSelection();}
+					public String getText() {
+						return EditionPanel.this.getTextSelection();
+					}
+					
 					@Override
-					public int getStartLine() {	return 0;}
+					public int getStartLine() {
+						return 0;
+					}
+					
 					@Override
-					public int getOffset() {return 0;}
+					public int getOffset() {
+						return 0;
+					}
+					
 					@Override
-					public int getLength() {return 0;}
+					public int getLength() {
+						return 0;
+					}
+					
 					@Override
-					public int getEndLine() {return 0;}
+					public int getEndLine() {
+						return 0;
+					}
 				};
 				return sel;
 			}
 			
 			@Override
-			public void addSelectionChangedListener(ISelectionChangedListener listener) { }
+			public void addSelectionChangedListener(ISelectionChangedListener listener) {}
 		};
 	}
 	
@@ -1243,12 +1337,13 @@
 	
 	public void goToPage(String name) {
 		
-		Page next = currentEdition.get(name);
+		Page next = currentEdition.getPageForName(name);
 		// System.out.println(Messages.TxmBrowser_4+currentPage);
 		if (next != null) {
 			currentPage = next;
 			this.setURL(currentPage.toURL());
-		} else {
+		}
+		else {
 			System.out.println(EditionUIMessages.bind(EditionUIMessages.pageNotFoundP0, name));
 		}
 	}
